﻿using Syncfusion.UI.Xaml.Charts;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace SfChartFlickerBug1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window, INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        private void OnPropertyRaised(string propertyname)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyname));
            }
        }

        private DispatcherTimer timer = new DispatcherTimer();
        private Random random = new Random(2397410);
        private Random random2 = new Random(114778);
        private Random random3 = new Random(789451);
        private const int seriesCount = 16;


        ChartSeriesCollection _series;
        public ChartSeriesCollection Series
        {
            get
            {
                return _series;
            }
            set
            {
                _series = value;
                OnPropertyRaised("Series");
            }
        }

        public class DataPoint : INotifyPropertyChanged
        {
            public event PropertyChangedEventHandler PropertyChanged;
            private void OnPropertyRaised(string propertyname)
            {
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs(propertyname));
                }
            }

            double _x, _y;

            public double X
            {
                get
                {
                    return _x;
                }
                set
                {
                    _x = value;
                    OnPropertyRaised("X");
                }
            }
            public double Y
            {
                get
                {
                    return _y;
                }
                set
                {
                    _y = value;
                    OnPropertyRaised("Y");
                }
            }
        }

        public MainWindow()
        {
            InitializeComponent();
            Series = new ChartSeriesCollection();
            this.DataContext = this;

            timer.Interval = TimeSpan.FromMilliseconds(250);
            timer.Tick += Timer_Tick;

            Generate();
            timer.Start();
        }

        private void Timer_Tick(object sender, EventArgs e)
        {
            Generate();
        }

        private void Generate()
        {
            if (Series.Count() == 0)
            {
                for (int i = 0; i < seriesCount; i++)
                    Series.Add(new FastLineBitmapSeries()
                    {
                        XBindingPath = "X",
                        YBindingPath = "Y",
                        StrokeThickness = 1
                    });
            }

            var list = new List<DataPoint>();
            for (int i = 0; i < seriesCount; i++)
            {
                var c = (random3.NextDouble() - 0.5) * 2;
                Series[i].ItemsSource = Enumerable.Range(0, 16000).Select(x => new DataPoint() { X = x, Y = (random.Next(0, 10) + random2.Next(0, 10) - 5) * c - i * 10 }).ToList();
            }
        }
    }
}
